import { isString } from '@/utils/is'
import type { RouteLocationRaw, Router } from 'vue-router'
import { useRouter } from 'vue-router'

export enum PageEnum {
  HOME = '/',
  NOT_FOUND = '/404',
}

export type RouteLocationRawEx = Omit<RouteLocationRaw, 'path'> & { path: PageEnum }

function handleError(e: Error) {
  console.error(e)
}

export function useGo(_router?: Router) {
  let router
  if (!_router) {
    router = useRouter()
  }
  const { push, replace } = (_router || router) as Router
  function go(opt: PageEnum | RouteLocationRawEx | string = '/', isReplace = false) {
    if (!opt) {
      return
    }

    const navigate = (route: RouteLocationRaw | string, isReplace: boolean) => {
      if (isReplace) {
        replace(route).catch(handleError)
      } else {
        push(route).catch(handleError)
      }
    }

    if (isString(opt)) {
      navigate(opt, isReplace)
    } else {
      const o = opt as RouteLocationRaw
      navigate(o, isReplace)
    }
  }
  return go
}
