import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import vueDevTools from 'vite-plugin-vue-devtools'
import Components from 'unplugin-vue-components/vite'
import { AntDesignVueResolver } from 'unplugin-vue-components/resolvers'

// https://vite.dev/config/
export default defineConfig({
  plugins: [
    vue(),
    vueDevTools(),
    Components({
      resolvers: [
        AntDesignVueResolver({
          importStyle: false, // css in js
        }),
      ],
    }),
  ],
  resolve: {
    alias: {
      '@': fileURLToPath(new URL('./src', import.meta.url)),
    },
  },
  build: {
    outDir: 'dist_bus',
  },
  server: {
    host: '0.0.0.0', //设置0.0.0.0和true 就是监听所有
    port: 5173,
    open: true,
    proxy: {
      '/jeecgbootbus': {
        target: 'http://192.168.0.119:9999',
        changeOrigin: true,
        ws: true,
        rewrite: (path) => path.replace(/^\/jeecgbootbus/, ''),
      },
    },
  },
})
